# Changelog

All notable changes to the func package will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [0.1.0] - 2024-12-04

### Added
- Initial release of func package
- Support for OpenAI and Anthropic LLM providers
- Function generation and storage functionality
- Automatic function execution capability
- Secure API key handling through environment variables
- Comprehensive logging system
- Error handling and validation
- Basic test suite
- Documentation

### Security
- Secure handling of API keys through environment variables
- Input validation for generated code
- Safe function storage mechanism

## [Unreleased]

### Planned
- Support for additional LLM providers
- Advanced function optimization
- Type hint generation
- Web interface
- Async function support
- Function chaining capabilities